﻿Imports System.Text

<Diagnostics.DebuggerDisplay("{Fullname}")> _
Public Class FtpItem
   Public ReadOnly Property Fullname As String
      Get
         With New StringBuilder
            If Parent IsNot Nothing Then .Append(Parent.Fullname)
            .Append("/" & Name)
            If IsDirectory Then .Append("/")
            Return .ToString
         End With
      End Get
   End Property
   Public Name As String
   Public IsDirectory As Boolean
   Public ReadOnly Childs As New List(Of FtpItem)
   Public Parent As FtpItem


   Public Sub SetName(line As IEnumerator(Of String))
      If Name Is Nothing Then Name = line.Current
      If line.MoveNext Then
         If line.Current = "" Then
            IsDirectory = True
         Else
            Dim chld = Childs.LastOrDefault
            If chld Is Nothing OrElse chld.Name <> line.Current Then
               chld = New FtpItem With {.Parent = Me}
               Childs.Add(chld)
            End If
            chld.SetName(line)
         End If
      End If
   End Sub

End Class
